--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   15:56:40 03/02/2015
-- Design Name:   
-- Module Name:   /home/lpetrica/Documents/git/vasile/rtl/hacm/hacm_tb.vhd
-- Project Name:  hacm
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: hacm
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
 
-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--USE ieee.numeric_std.ALL;
 
ENTITY hacm_tb IS
END hacm_tb;
 
ARCHITECTURE behavior OF hacm_tb IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT hacm
    PORT(
         clk_i : IN  std_logic;
         rst_i : IN  std_logic;
         f_or_s_i : IN  std_logic;
         lock_o : OUT  std_logic;
         clk_o : OUT  std_logic;
        -- configuration interface
        reg_clk   : in std_logic;
        reg_rden  : in std_logic;
        reg_wren  : in std_logic;
        reg_wstrb : in std_logic_vector(3 downto 0);
        reg_rd_data : out std_logic_vector(31 downto 0);
        reg_wr_data : in std_logic_vector(31 downto 0);
        reg_addr    : in std_logic_vector(31 downto 0)
        );
    END COMPONENT;
    

   --Inputs
   signal clk_i : std_logic := '0';
   signal rst_i : std_logic := '0';
   signal f_or_s_i : std_logic := '0';
   signal ts_i : std_logic_vector(7 downto 0) := "01011000";--11.0ns
   signal tf_i : std_logic_vector(7 downto 0) := "01010000";--10.0ns
   signal to_i : std_logic_vector(7 downto 0) := "01100100";--12.5ns
   signal tsw_i : std_logic_vector(7 downto 0) := "01110000";--14.0ns

   signal  reg_clk   : std_logic;
   signal  reg_rden  : std_logic;
   signal  reg_wren  : std_logic;
   signal  reg_wstrb : std_logic_vector(3 downto 0);
   signal  reg_rd_data : std_logic_vector(31 downto 0);
   signal  reg_wr_data : std_logic_vector(31 downto 0);
   signal  reg_addr    : std_logic_vector(31 downto 0);


   signal alternate_period : integer := 10;
   signal alternate_counter : integer := 0;

 	--Outputs
   signal lock_o : std_logic;
   signal clk_o : std_logic;

   -- Clock period definitions
   constant clk_i_period : time := 10 ns;
   constant clk_o_period : time := 10 ns;
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: hacm PORT MAP (
          clk_i => clk_i,
          rst_i => rst_i,
          f_or_s_i => f_or_s_i,
          lock_o => lock_o,
          clk_o => clk_o,
          reg_clk => reg_clk,
          reg_addr => reg_addr,
          reg_rden => reg_rden,
          reg_wren => reg_wren,
          reg_wstrb => reg_wstrb,
          reg_wr_data => reg_wr_data,
          reg_rd_data => reg_rd_data
        );

   -- Clock process definitions
   clk_i_process :process
   begin
		clk_i <= '0';
		wait for clk_i_period/2;
		clk_i <= '1';
		wait for clk_i_period/2;
   end process;

   reg_clk_process :process
   begin
        reg_clk <= '0';
        wait for clk_i_period/4;
        reg_clk <= '1';
        wait for clk_i_period/4;
   end process;


   process(clk_o)
   begin
    if(clk_o'event and clk_o = '1') then
        if(alternate_counter = alternate_period) then
            f_or_s_i <= '1';
            alternate_counter <= 0;
        else
            f_or_s_i <= '0';
            alternate_counter <= alternate_counter + 1;
        end if;
    end if;
   end process;

   -- Stimulus process
   stim_proc: process
   begin
      reg_rden <= '0';
      reg_wren <= '0';
      reg_addr <= (others=>'0');
      rst_i <= '1';
      wait for 100 ns;
      rst_i <= '0';
      wait for 100 ns;
      -- write HACM CTLSTS register to reset the HACM
      wait until reg_clk'event and reg_clk = '1';
      reg_rden <= '0';
      reg_wren <= '1';
      reg_wr_data <= x"00000004";
      reg_addr(9 downto 2) <= "00000000";
      wait until reg_clk'event and reg_clk = '1';
      reg_rden <= '0';
      reg_wren <= '0';
      wait for 100 ns;

      -- write HACM CTLSTS register to de-reset the HACM
      wait until reg_clk'event and reg_clk = '1';
      reg_rden <= '0';
      reg_wren <= '1';
      reg_wr_data <= x"00000000";
      reg_addr(9 downto 2) <= "00000000";
      wait until reg_clk'event and reg_clk = '1';
      reg_rden <= '0';
      reg_wren <= '0';

      -- wait until after MMCM locks.
      wait until lock_o = '1';
      wait for 100 ns;
      -- insert stimulus here 
      -- read HACM STS register
      wait until reg_clk'event and reg_clk = '1';
      reg_rden <= '1';
      reg_wren <= '0';
      reg_addr(9 downto 2) <= "00000000"; 
      -- write HACM TPAR register
      wait until reg_clk'event and reg_clk = '1';
      reg_addr(9 downto 2) <= "00000001"; 
      reg_rden <= '0';
      reg_wren <= '1';
      reg_wr_data <= tsw_i & to_i & tf_i & ts_i;
      wait until reg_clk'event and reg_clk = '1';
      reg_rden <= '0';
      reg_wren <= '0';

      wait for 100ns;
      -- read HACM DRP registers for CLKOUT4
      wait until reg_clk'event and reg_clk = '1';
      reg_rden <= '1';
      reg_wren <= '0';
      reg_addr(9 downto 2) <= "10010000";
      wait until reg_clk'event and reg_clk = '1';
      reg_rden <= '0';
      reg_wren <= '0';
      wait for 100 ns;
      -- first read is never successful, but second is
      wait until reg_clk'event and reg_clk = '1';
      reg_rden <= '1';
      reg_wren <= '0';
      reg_addr(9 downto 2) <= "10010000";
      wait until reg_clk'event and reg_clk = '1';
      reg_rden <= '0';
      reg_wren <= '0';
      -- read HACM DRP registers for CLKOUT4
      wait for 100 ns;
      wait until reg_clk'event and reg_clk = '1';
      reg_rden <= '1';
      reg_wren <= '0';
      reg_addr(9 downto 2) <= "10010001";
      wait until reg_clk'event and reg_clk = '1';
      reg_rden <= '0';
      reg_wren <= '0';
      wait for 100 ns;
      -- first read is never successful, but second is
      wait until reg_clk'event and reg_clk = '1';
      reg_rden <= '1';
      reg_wren <= '0';
      reg_addr(9 downto 2) <= "10010001";
      wait until reg_clk'event and reg_clk = '1';
      reg_rden <= '0';
      reg_wren <= '0';
      wait for 100ns;
      
      -- write HACM CTLSTS register to reset the HACM
      wait until reg_clk'event and reg_clk = '1';
      reg_rden <= '0';
      reg_wren <= '1';
      reg_wr_data <= x"00000004";
      reg_addr(9 downto 2) <= "00000000";
      wait until reg_clk'event and reg_clk = '1';
      reg_rden <= '0';
      reg_wren <= '0';
      wait for 100 ns;

      -- write DRP register 1 for CLKOUT4 to increase frequency
      wait until reg_clk'event and reg_clk = '1';
      reg_rden <= '0';
      reg_wren <= '1';
      reg_wr_data <= x"00001187";
      reg_addr(9 downto 2) <= "10010000";
      wait until reg_clk'event and reg_clk = '1';
      reg_rden <= '0';
      reg_wren <= '0';
      wait for 100 ns;

      -- write HACM CTLSTS register to de-reset the HACM
      wait until reg_clk'event and reg_clk = '1';
      reg_rden <= '0';
      reg_wren <= '1';
      reg_wr_data <= x"00000000";
      reg_addr(9 downto 2) <= "00000000";
      wait until reg_clk'event and reg_clk = '1';
      reg_rden <= '0';
      reg_wren <= '0';

      -- wait for MMCM to re-lock
      wait until lock_o = '1';
      wait for 100 ns;

      -- write HACM PSCTL register to do phase shift (increment)
      wait until reg_clk'event and reg_clk = '1';
      reg_rden <= '0';
      reg_wren <= '1';
      reg_wr_data <= x"00000001";
      reg_addr(9 downto 2) <= "00001000";
      wait until reg_clk'event and reg_clk = '1';
      reg_rden <= '0';
      reg_wren <= '0';

      wait for 100 ns;

      wait until reg_clk'event and reg_clk = '1';
      reg_rden <= '0';
      reg_wren <= '1';
      reg_wr_data <= x"00000001";
      reg_addr(9 downto 2) <= "00001000";
      wait until reg_clk'event and reg_clk = '1';
      reg_rden <= '0';
      reg_wren <= '0';


      wait for 20 us;
      alternate_period <= 9;
      wait for 20 us;
      alternate_period <= 8;
      wait for 20 us;
      alternate_period <= 7;
      wait for 20 us;
      alternate_period <= 6;
      wait for 20 us;
      alternate_period <= 5;
      wait for 20 us;
      alternate_period <= 4;
      wait for 20 us;
      alternate_period <= 3;
      wait for 20 us;
      alternate_period <= 2;
      wait for 20 us;
      alternate_period <= 1;
      wait;
   end process;

END;
